#ifndef __SITECING_SITECING_INTERFACE_H
#define __SITECING_SITECING_INTERFACE_H

#include <ostream>

/**
 * @file
 * @brief The sitecing_interface call declaration.
 */

namespace sitecing {
    using namespace std;

    /**
     * @brief the interface to site-C-ing.
     *
     * The basic class used to convey communications between the component and
     * the sitecing core.
     */
    class sitecing_interface {
	public:
	    /**
	     * Pointer to the output stream.
	     */
	    ostream *out;

	    /**
	     * The default constructor doesn't do much.
	     */
	    sitecing_interface() : out(0) {}
	    /**
	     * The constructor initializes the output stream pointer.
	     * @param o the value to initialize the output stream pointer with.
	     */
	    sitecing_interface(ostream* o) : out(o) {}
    };

}

#endif /* __SITECING_SITECING_INTERFACE_H */
